#Module-Specific definitions
%define rversion 2.06
%define revision r179569

%define mod_name mod_apreq
%define mod_conf 76_%{mod_name}.conf
%define mod_so %{mod_name}2.so

%define apache_version 2.0.54

%define	major 2
%define libname	%mklibname apreq %{major}

Summary:	Apache Request Library
Name:		libapreq2
Version:	%{rversion}
#Release:	%mkrel 3.%{revision}.1
Release:	%mkrel 4.dev.1
License:	Apache License
Group:          System/Libraries
URL:		http://httpd.apache.org/apreq/
#Source0:	libapreq2-%{rversion}-dev-SVN-%{revision}.tar.bz2
Source0:	http://www.apache.org/dist/httpd/libapreq/libapreq2-%{rversion}-dev.tar.gz
Source1:	http://www.apache.org/dist/httpd/libapreq/libapreq2-%{rversion}-dev.tar.gz.asc
Source2:	76_mod_apreq.conf.bz2
Patch0:		libapreq2-2.03-dev-version_check_fix.diff.bz2
BuildRequires:	autoconf2.5
BuildRequires:	automake1.7
BuildRequires:	chrpath
BuildRequires:	perl-devel
BuildRequires:	perl-Tie-IxHash
BuildRequires:	perl-ExtUtils-XSBuilder
BuildRequires:	perl-Parse-RecDescent
BuildRequires:	apache-mod_perl-devel
BuildRequires:	apache-devel >= %{apache_version}
BuildRequires:	apache-source >= %{apache_version}
BuildRoot:	%{_tmppath}/%{name}-%{version}

%description
libapreq is a safe, standards-compliant, high-performance library used for
parsing HTTP cookies, query-strings and POST data. The original version
(libapreq-1.X) was designed by Lincoln Stein and Doug MacEachern. The perl
APIs Apache::Request and Apache::Cookie are the lightweight mod_perl analogs of
the CGI and CGI::Cookie perl modules.

This package contains the shared libraries for %{name}

%if "%{_lib}" != "lib"
%package -n	%{libname}
Summary:	Apache Request Library
Version:	%{rversion}
Group: 		System/Libraries

%description -n	%{libname}
libapreq is a safe, standards-compliant, high-performance library used for
parsing HTTP cookies, query-strings and POST data. The original version
(libapreq-1.X) was designed by Lincoln Stein and Doug MacEachern. The perl
APIs Apache::Request and Apache::Cookie are the lightweight mod_perl analogs of
the CGI and CGI::Cookie perl modules.

This package contains the shared libraries for %{name}
%endif

%package -n	%{libname}-devel
Summary:	Development library and header files for the Apache Request Library
Version:	%{rversion}
Group:		Development/C
Requires:	%{libname} = %{version}
Provides:	libapreq-devel

%description -n	%{libname}-devel
libapreq is a safe, standards-compliant, high-performance library used for
parsing HTTP cookies, query-strings and POST data. The original version
(libapreq-1.X) was designed by Lincoln Stein and Doug MacEachern. The perl
APIs Apache::Request and Apache::Cookie are the lightweight mod_perl analogs of
the CGI and CGI::Cookie perl modules.

This package contains the development library and its header files.

%package -n	perl-libapreq2
Summary:	Apache Request Library Perl Glue
Version:	%{rversion}
Group:		System/Servers
Requires:	apache-mod_perl

%description -n perl-libapreq2
libapreq is a safe, standards-compliant, high-performance library used for
parsing HTTP cookies, query-strings and POST data. The original version
(libapreq-1.X) was designed by Lincoln Stein and Doug MacEachern. The perl
APIs Apache::Request and Apache::Cookie are the lightweight mod_perl analogs of
the CGI and CGI::Cookie perl modules.

%package -n	apache-%{mod_name}
Summary:	Mod_%{rname} is a DSO module for the apache Web server
Version:	%{apache_version}_%{rversion}
Group:		System/Servers
Requires(pre): rpm-helper
Requires(postun): rpm-helper
Requires(pre):	apache-conf >= 2.0.54
Requires(pre):	apache >= %{apache_version}
Requires:	apache-conf >= 2.0.54
Requires:	apache >= %{apache_version}
Requires:	perl-libapreq2 = %{rversion}
Provides:	apache2-%{mod_name}
Obsoletes:	apache2-%{mod_name}

%description -n	apache-%{mod_name}
Mod_%{name} is a DSO module for the apache Web server.

%prep

%setup -q -n libapreq2-2.06-dev
%patch0 -p0

# got the idea why this wasn't working from debian, thanks guys!
# P0 combined with this hack fixes it all...
perl -pi -e "s|_APACHE2_REAL_VERSION_|%{apache_version}|g" build/version_check.pl

bzcat %{SOURCE2} > %{mod_conf}

%build
export WANT_AUTOCONF_2_5=1
libtoolize --copy --force && aclocal-1.7 && autoconf && autoheader && automake-1.7 -a -c

%configure2_5x \
    --with-apache2-apxs=%{_sbindir}/apxs

%make

# Build the perl modules
pushd glue/perl
    %{__perl} ../../build/xsbuilder.pl run
    CFLAGS="%{optflags}" %{__perl} Makefile.PL -apxs %{_sbindir}/apxs INSTALLDIRS=vendor
    %make
    mv Makefile Makefile.xx
popd

make test

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%makeinstall_std

# move the module in place
install -d %{buildroot}%{_libdir}/apache-extramodules
mv %{buildroot}%{_libdir}/apache/*.so %{buildroot}%{_libdir}/apache-extramodules/

# install module conf files for the "conf.d" dir loading structure
install -d %{buildroot}%{_sysconfdir}/httpd/modules.d
install -m0644 %{mod_conf} %{buildroot}%{_sysconfdir}/httpd/modules.d/

# install one extra devel file
install -m0755 apreq*-config %{buildroot}%{_bindir}/

# install the perl stuff
pushd glue/perl
cp Makefile.xx Makefile
%makeinstall_std
popd

# nuke rpath
find %{buildroot}%{perl_vendorlib} -name "*.so" | xargs chrpath -d

# cleanup
rm -rf %{buildroot}%{_libdir}/apache

%post -n %{libname} -p /sbin/ldconfig

%postun -n %{libname} -p /sbin/ldconfig

%post -n apache-%{mod_name}
if [ -f %{_var}/lock/subsys/httpd ]; then
    %{_initrddir}/httpd restart 1>&2;
fi

%postun -n apache-%{mod_name}
if [ "$1" = "0" ]; then
    if [ -f %{_var}/lock/subsys/httpd ]; then
	%{_initrddir}/httpd restart 1>&2
    fi
fi

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files -n %{libname}
%defattr(-,root,root)
%doc CHANGES INSTALL README
%{_libdir}/libapreq*.so.*

%files -n %{libname}-devel
%defattr(-,root,root)
%doc CHANGES INSTALL README
%{_bindir}/apreq*-config
%{_libdir}/libapreq*.so
%{_libdir}/libapreq*.la
%{_libdir}/libapreq*.a
%{_includedir}/apreq*
%{_includedir}/apache/apreq*

%files -n apache-%{mod_name}
%defattr(-,root,root)
%doc CHANGES INSTALL README
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/httpd/modules.d/%{mod_conf}
%attr(0755,root,root) %{_libdir}/apache-extramodules/%{mod_so}

%files -n perl-libapreq2
%defattr(-,root,root)
%doc CHANGES INSTALL README
%{perl_vendorlib}/*/auto/APR/Request/*
%{perl_vendorlib}/*/Apache2/*
%{perl_vendorlib}/*/APR/*
%{_mandir}/man3/*

%changelog
* Thu Sep 08 2005 Oden Eriksson <oeriksson@mandriva.com> 2.06-4.dev.1mdk
- rebuild

* Tue Aug 30 2005 Oden Eriksson <oeriksson@mandriva.com> 2.06-2.dev.2mdk
- rebuilt against new openldap-2.3.6 libs

* Sat Jul 30 2005 Oden Eriksson <oeriksson@mandriva.com> 2.06-1.dev.2mdk
- fix deps

* Thu Jul 21 2005 Oden Eriksson <oeriksson@mandriva.com> 2.06-1.dev.1mdk
- 2.06-dev

* Thu Jun 02 2005 Oden Eriksson <oeriksson@mandriva.com> 2.06-0.r179569.1mdk
- new SVN snap (r179569)
- rename the apache sub package (apache2/apache)
- the conf.d directory is renamed to modules.d
- use new rpm-4.4.x pre,post magic
- use better %%post and %%postun magic
- fix naming

* Sun Mar 20 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.05-0.r161185.1mdk
- use a recent cvs snap (r161185)
- run the tests

* Sun Mar 20 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.04_03-6mdk
- use the %%mkrel macro

* Fri Feb 18 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.04_03-5mdk
- spec file cleanups, remove the ADVX-build stuff

* Wed Feb 09 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.04_03-4mdk
- rebuilt for apache 2.0.53

* Fri Feb  4 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.04_03-3mdk
- rebuilt against new openldap libs

* Tue Dec 07 2004 Rafael Garcia-Suarez <rgarciasuarez@mandrakesoft.com> 2.04_03-2mdk
- Rebuild for new perl
- Remove MANIFEST files

* Fri Sep 03 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.04_03-1mdk
- 2.04_03

* Tue Aug 10 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.03_04-3mdk
- rebuilt

* Sun Aug 01 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.03_04-2mdk
- rebuilt for apache 2.0.50

* Mon Jun 21 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.03_04-1mdk
- initial mandrake package based on the spec file by Bojan Smojver
